// main cpp containing loop, opengl, and glut keyboard input

//main libraries

//header file containing classes
#include "main.h"

CCamera	g_Camera;

// Enables "multi-pressed" key combinations by using keyIndex as a key map
char keyIndex[256];

void init(void)
{
		glEnable(GL_DEPTH_TEST);
		glClearColor (0.0, 0.0, 0.0, 0.0);
		glShadeModel (GL_SMOOTH);
		glutSetCursor(GLUT_CURSOR_NONE);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();	
		gluPerspective(45.0f,1, 0.5f, 150.0f);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		g_Camera.Position(0, 0.5f, 6,   0, 0.5f, 0,   0, 1, 0);
}

void display(void)
{

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();	
	g_Camera.look();
	glBegin(GL_TRIANGLES);
	
	glColor3f(1.0, 0.2, 0.0);
	glVertex3f(1.0,0.0,0.0);

	glColor3f(1.0, 1.0, 0.0);
	glVertex3f(0.0,1.0,0.0);

	
	glColor3f(0.0, 0.2, 1.0);
	glVertex3f(-1.0,0.0,0.0);
	glEnd();

	glutSwapBuffers();
	g_Camera.update();
		
}


void keyboard(int key, int x, int y)
{
keyIndex[(char)key]=1;
	

}
void keyUp(int key, int x, int y)
{
keyIndex[key]=0;
}


void mouseMotion(int x, int y)
{
	g_Camera.mouseView(x,y);
}

void mouse(int button, int state, int x, int y)
{
	
}

void idle()
{
	g_Camera.update();
}


void main(int argc,char *argv[])
{
	glutInit(&argc,argv); 
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
	glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);	
	glutInitWindowPosition(120,120);
	glutCreateWindow("camera class's ");
	init();  
	glutSpecialFunc(keyboard);
	glutSpecialUpFunc(keyUp);
	glutMouseFunc(mouse);
	glutMotionFunc(mouseMotion);
	glutPassiveMotionFunc(mouseMotion);
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	glutMainLoop();
}
