#ifndef _VEC_H
#define _VEC_H

class CVector3 
{							//simple vector class (3 floats)
public:

	//////////////////////CONSTRUCTORS//////////////////
////////////////////////////////////////////////////
	//constructor no aruements
	CVector3() 
	{x=0; y=0; z=0;}
	
	//second constructor takes intial arguements
	CVector3(float Xaxis,float Yaxis,float Zaxis)
{ x = Xaxis; y = Yaxis; z = Zaxis; }

	//////////////////////OPERATORS/////////////////////
////////////////////////////////////////////////////

	// + adding the vector
	CVector3 operator+ (CVector3 added)
		{
		return CVector3 (x + added.x, y + added.y, z + added.z);
		}
	
	// - subtracting the vector
	CVector3 operator- (CVector3 subtract)
		{
		return CVector3 (x - subtract.x, y - subtract.y, z - subtract.z);
		}

	// * multiplying the vector
	CVector3 operator* (CVector3 multiply)
		{
		return CVector3 (x * multiply.x, y * multiply.y, z * multiply.z);
		}

	// / dividind a vector
	CVector3 operator/ (CVector3 divided)
		{
		return CVector3 ( x / divided.x, y / divided.y, z / divided.z);
		}

		// / dividind a vector by scalar
	CVector3 operator/ (float divided)
		{
		return CVector3 ( x / divided, y / divided, z / divided);
		}
			
		// * multiply by a scalar
	CVector3 operator* (float mult)
		{
		return CVector3 ( x * mult, y * mult, z * mult);
		}

void crossProduct(CVector3 vec1, CVector3 vec2);//calculates the cross product of two vectors 
												//storing the result in this classes xyz floats
void norm(void);//normalises the vector in this class


	//////////////////////VARIBLES///////////////////////
//////////////////////////////////////////////////////

		float x, y, z;		//cartisan coordinates
};

//////////////////////////////////////////////////////////////////////////////
/// VECTOR 2	
//////////////////////////////////////////////////////////////////////////////
// This is our 2D point class.  This will be used to store the UV coordinates.

class CVector2 
{
public:
	float x, y;
};

#endif