//tga loader
#include "main.h"
#include "textureClass.h"

void Ctextures::loader (char* filename)


{
//print loading file
printf ("loading %s   ", filename);


//checking pixel openGL alignment
glPixelStorei(GL_UNPACK_ALIGNMENT,1);

FILE			*filePtr;				//the file pointer
long			size;					//image size
unsigned char	imageType=0;			//image type RLE ?
unsigned char	bits = 0;				//16, 24 or 32 bits
int				i = 0;					//A counter
unsigned char 	swap;					//char to store swap of blue and red
		
//	loading the file in read binary mode
	filePtr = fopen(filename, "rb");
	if (!filePtr)
	{
		printf("file not found\n");
		return ;
	}

//skip 2 useless data bytes
fseek (filePtr, 2, SEEK_SET);

//read image type
fread(&imageType, sizeof(unsigned char), 1,filePtr);

//move on 9 bytes
fseek(filePtr, 9, SEEK_CUR); 

//reading width, height and bits per pixel(16, 24 or 32 )
fread(&sizeX, sizeof(short int), 1, filePtr);
fread(&sizeY, sizeof(short int), 1, filePtr);
fread(&bits, sizeof(unsigned char), 1, filePtr);
			

//moving it on to the image data section
fseek(filePtr, sizeof(unsigned char), SEEK_CUR); 

//	checking the file formating 
//	THEN READ THE DATA

	if (imageType != TGA_RLE)
	{
		if(bits == 24 || bits == 32)
		{
			channels= bits /8;	//channels alpha or not (4 or 3)
			size=sizeX*sizeY*channels;	//imagesize
			
			//allocate data and then load int file
			data =(unsigned char*)malloc(sizeof(unsigned char)*size);
			fread(data, sizeof(unsigned char)*size,1, filePtr);

			//swap red and blues around because they are stored the wrong way round
			for (i=0; i<=size; i+=channels)
			{
			swap=data[i];
			data[i]=data[i+2];
			data[i+2]=swap;
			}
		}
		else if (bits == 16)
		{
			unsigned short pixels = 0;
			int r=0, g=0, b=0;
			channels = 3;
			size=sizeX*sizeY*channels;	//imagesize
			fread(data, sizeof(unsigned char),size, filePtr);
			
			// Load in all the pixel data pixel by pixel
			for( i = 0; i < size; i++)
			{
				// Read in the current pixel
				fread(&pixels, sizeof(unsigned short), 1, filePtr);
				
				// 0x1f = 11111 in binary, so since 5 bits are reserved in
				b = (pixels & 0x1f) << 3;
				g = ((pixels >> 5) & 0x1f) << 3;
				r = ((pixels >> 10) & 0x1f) << 3;
				
				// This essentially assigns the color to our array and swaps the
				// B and R values at the same time.
				data[i * 3 + 0] = r;
				data[i * 3 + 1] = g;
				data[i * 3 + 2] = b;
			}
		}
		else
		{
			printf("not bit support for file\n");
		}
		
	}

//print loading successful
printf ("complete\n");
return ;
}

unsigned short Ctextures:: get_GL_channels(void)
{
	if (channels=3)
	//GL_RGB
	return 0x1907;

	else
		if (channels=4)
		//GL_RGBA
		return 0x1908;
}



void Ctextures:: createTexture(GLuint textureName)
{
	//generate a or many textures (0 here?) and that in a name or a array
	glGenTextures(0, &textureName);
	//bind texture to a 1D, 2D or 3D
	glBindTexture(GL_TEXTURE_2D, textureName);
	
	//gl parameters for WRAPPING and mip mapping
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	
	//loading the file into opengl as a texture
	glTexImage2D(GL_TEXTURE_2D, 0, get_GL_channels(), sizeX, sizeY,
						0, get_GL_channels(), GL_UNSIGNED_BYTE, data);

}

void Ctextures:: material()
{
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
}

Ctextures:: Ctextures()
{
mat_specular[0]=1.0;	mat_specular[1]=0.81; mat_specular[2]=0.7;	mat_specular[3]=1.0;	
mat_shininess[0]=11.0;
}