#include "main.h"
#include "objloader.h"		

objLoader::objLoader(void)//constructor
{
	frames		=1;
	info_faces	=0;						
	info_vertexs=0;
	info_UVs	=0;
	info_normals=0;
	long	total_faces=0;
	faceRead	=false;
}


bool objLoader::ImportObj(obj_model *CurrentObj_model, char *fileName)
{
	if(!fileName)		//return false if no name given
	{
		cout << "error objLoader.import() no filename passed in!" << endl;
		return false;
	}
	else
		obj_file_pointer = fopen(fileName, "r");	//open obj file ..storing the adress in our class file pointer

	if (!obj_file_pointer)
	{
		cout << "error objLoader.import() no file of that name!" << endl;	//if the file pointer initialised
		return false;
	}
//read in file info
readObj();
	if (frames == 1)
			{
				info_faces		=long(obj_faces.size());						
				info_vertexs	=long(obj_vertices.size());
				info_UVs		=long(obj_texUVs.size());
				info_normals	=long(obj_normals.size());
			}
//fill in object fill
fill_in_object(CurrentObj_model);

cout<<"frames: "<<frames<<endl;
cout<<"faces: "<<info_faces<<endl;
cout<<"vertexs: "<<info_vertexs<<endl;
cout<<"UVs: "<<info_UVs<<endl;
cout<<"normals: "<<info_vertexs<<endl;
cout<<"total faces:"<<total_faces<<endl;
return true;
}


///////////////////////////////////////////////////////////////////////////////
//reads in face info///////////////////////////////////////////////////////////
void objLoader::readFaceInfo(void)
{
	total_faces++;
	polyFace newFace		={0};	//we will load are face info here first
	char garbageStr[255]	={0};	//we read in the rest of the line with this wasted varible

	{
		fscanf(obj_file_pointer, "%d/%d/%d %d/%d/%d %d/%d/%d",   &newFace.vertIndex[0], &newFace.coordIndex[0], &newFace.normalIndex[0],
																 &newFace.vertIndex[1], &newFace.coordIndex[1], &newFace.normalIndex[1],
																 &newFace.vertIndex[2], &newFace.coordIndex[2], &newFace.normalIndex[2]);
	//	cout <<"vertexIndex "<< newFace.vertIndex[0] << " " <<newFace.vertIndex[1]<<" "<<newFace.vertIndex[2]<<endl;
	}
//offseting faces to zero
newFace.vertIndex[0]--;
newFace.coordIndex[0]--;
newFace.normalIndex[0]--;
newFace.vertIndex[1]--;
newFace.coordIndex[1]--;
newFace.normalIndex[1]--;
newFace.vertIndex[2]--;
newFace.coordIndex[2]--;
newFace.normalIndex[2]--;

	fgets(garbageStr, 100, obj_file_pointer);//read rest of the line

	obj_faces.push_back(newFace);//pushs a face into the vector array obj_faces

}

///////////////////////////////////////////////////////////////////////////////
//reads in vertex/texUvs info/////////////////////////////////////////////////
void objLoader::readVertexInfo(void)
{
	CVector3 newVertex3d		;//3d vector to store vertex position
	CVector3 newNormal3d		;//3d vector to store normal vector
	CVector2 newTexCoord2d		= {0};//2d vector to store tex coordinates
	char garbageStr[255]		= {0};//we read in the rest of the line with this wasted varible
	char ch						=  0; //our swicth char

	ch = fgetc(obj_file_pointer);	// get next letter after V could be " " or "t" or "f"
	if(ch == ' ')				// if space must be a vertex
	{


		// here we read in the xyz of the vertex
		fscanf(obj_file_pointer, "%f %f %f", &newVertex3d.x, &newVertex3d.y, &newVertex3d.z); 
		//cout<<"vertex values x = "<<newVertex3d.x<<" y = "<<newVertex3d.y<<" z = "<<newVertex3d.z<<endl;
		// skip to the end of the line
		//fgets(garbageStr, 100, obj_file_pointer);

		//push the vertex on to the stack
		obj_vertices.push_back(newVertex3d);
		//cout<<obj_vertices.size()<<endl;
		

	}
	if(ch == 't')			// if we get a "t" its a vt a tex UV
	{
		fscanf(obj_file_pointer, "%f %f", &newTexCoord2d.x, &newTexCoord2d.y);
		fgets(garbageStr, 1,obj_file_pointer );
		obj_texUVs.push_back(newTexCoord2d);
		//cout<<newTexCoord2d.x<<" "<<newTexCoord2d.y<<endl;
	}
	if(ch == 'n')
	{
		
	//lets get those normals 
	fscanf(obj_file_pointer, "%f %f %f",  &newNormal3d.x, &newNormal3d.y, &newNormal3d.z);
	fgets(garbageStr, 100, obj_file_pointer);
	obj_normals.push_back(newNormal3d);
	//cout<<obj_normals.size()<<endl;
	}
	else		//else an evil normal
	{
		// We calculate our own normals at the end so we read past them.
		fgets(garbageStr, 100, obj_file_pointer);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////


void objLoader::readObj(void)
{
	char garbageStr[255]		= {0};
	char ch						= 0;
	//int counter=0;
	while(!feof(obj_file_pointer))
	{
		// Get the beginning character of the current line in the .obj file
		ch = fgetc(obj_file_pointer);
		
		switch(ch)
		{
		case 'v':						//   could be 'v' or 'vt' or 'vn' 
			
			readVertexInfo();
			
			

			if (faceRead==true)
			{
				objects_face_count.push_back(long(obj_faces.size()));
				cout<<long(obj_faces.size())<<endl;
				frames++;
			}
			if (frames == 2)	//for multiple objects we take the object info here
			{
				info_faces		=long(obj_faces.size());						
				info_vertexs	=long(obj_vertices.size());
				info_UVs		=long(obj_texUVs.size());
				info_normals	=long(obj_normals.size());
			}


			faceRead=false;
			break;

		case 'f':						// face header
			
			readFaceInfo();
			faceRead=true;
			break;

		
		default:

			//skip line
			fgets(garbageStr, 100, obj_file_pointer);
			break;
		}
	}

}



void objLoader::fill_in_object(obj_model *setup_model)
{




//NEWWWWW!!!!
setup_model->number_of_vertexs	= long(obj_vertices.size() );
setup_model->number_of_UVs		= long(obj_texUVs.size()   );
setup_model->number_of_normals  = long(obj_normals.size()  );
setup_model->number_of_faces	= long(obj_faces.size()    );
setup_model->background_faces	= total_faces;


//NNNEW NEWWW!!!!!!!!!!!
setup_model->vertex_array	= new float [obj_vertices.size()*3];	//float x3 xyz in 1 array
setup_model->UV_array		= new float [obj_texUVs.size()*2];		//float x2 xyz in 1 array
setup_model->normal_array	= new float [obj_normals.size()*3];		//float x3 xyz in 1 array
setup_model->face_array		= new long  [obj_faces.size()*9];		//long  x9 index 3 verts 3 tex 3 normals in 1 array
setup_model->material_ID	= new GLuint[material_number.size()];	//allocate material number


//NNNEWWWWWWEEERR!!!
//load vertex array
int g=0;
for (int i= 0; i < setup_model->number_of_vertexs; i++)
{
	g=i;
	if(i!=0)
		g=i*3;
    setup_model->vertex_array[g] = obj_vertices[i].x;
	setup_model->vertex_array[g+1] = obj_vertices[i].y;
	setup_model->vertex_array[g+2] = obj_vertices[i].z;
}
//load UVs
for (i= 0; i < setup_model->number_of_UVs; i++)
{
	g=i;
	if(i!=0)
		g=i*2;
    setup_model->UV_array[g]	= obj_texUVs[i].x;
	setup_model->UV_array[g+1]	= obj_texUVs[i].y;
	
}

// load normals
for (i= 0; i < setup_model->number_of_normals; i++)
{
	g=i;
	if(i!=0)
		g=i*3;
    setup_model->normal_array[g]	= obj_normals[i].x;
	setup_model->normal_array[g+1]	= obj_normals[i].y;
	setup_model->normal_array[g+2]	= obj_normals[i].z;
}

//load material IDS


//faces
for (i=0; i < setup_model->number_of_faces; i++)
{
	g=i;
	if(i!=0)
		g=i*9;
	//vertex index storing
	setup_model->face_array[g]	 = obj_faces[i].vertIndex[0];
	setup_model->face_array[g+1] = obj_faces[i].vertIndex[1];
	setup_model->face_array[g+2] = obj_faces[i].vertIndex[2];
	// coordIndex storing
	setup_model->face_array[g+3] = obj_faces[i].coordIndex[0];
	setup_model->face_array[g+4] = obj_faces[i].coordIndex[1];
	setup_model->face_array[g+5] = obj_faces[i].coordIndex[2];
    // normal index storing
	setup_model->face_array[g+6] = obj_faces[i].normalIndex[0];
	setup_model->face_array[g+7] = obj_faces[i].normalIndex[1];
	setup_model->face_array[g+8] = obj_faces[i].normalIndex[2];
}
//set details of vert norms etc (which will not change per frame
setup_model->number_of_faces	=	info_faces;				
setup_model->number_of_vertexs	=	info_vertexs;
setup_model->number_of_UVs		=	info_UVs;
setup_model->number_of_normals	=	info_normals;


	
//add one to our obj_object counter
setup_model->number_of_objects=frames;

//clear our link lists
obj_vertices.clear();
obj_texUVs.clear();
obj_normals.clear();
obj_faces.clear();
}
