#ifndef _OBJLOADER_H
#define _OBJLOADER_H
#include "main.h"

// this is an obj loader class taking in the vertex position, texture Uvs and face info???
class polyface;
class obj_object;
class obj_model;

class objLoader
{
public:
	
		bool ImportObj(obj_model* CurrentObj_model, char *fileName);	//takes in obj filename


		FILE *obj_file_pointer;			//file pointer 
		vector<CVector3> obj_vertices;	//vector array vertices
		vector<CVector3> obj_normals;	//vector array normals
		vector<polyFace> obj_faces;		//vector array faces
		vector<CVector2> obj_texUVs;	//tex uvs
		bool faceRead;					//did we just read a face			
		int  frames;					//frames of animation
		long info_faces;				//how many in shape
		long info_vertexs;
		long info_UVs;
		long info_normals;
		long total_faces;
		vector<GLuint>	material_number;		//stores our object materials
		vector<long>	objects_face_count;		//stores the number of faces each object/frame has

        
		
 ///////////////////////////////////////////////////////////////////////////////////////////
//functions called by the LOADER OBJ///////////////////////////////////////////////////////
objLoader(void);				//constructor
void readFaceInfo(void);		//reads uv and vertex numbers
void readObj(void);				//reads in object for import function
void readVertexInfo(void);		//reads vertex info for read function
void fill_in_object(obj_model *setup_model);	//object filler
};



//model with multiple objects
class obj_model
{
public:
	
	//varibles
	
	GLuint	*material_ID;			//material ID each object can have its own id
	long	background_faces;		//if zero object not a background object
    int		number_of_objects;		//how many objects or frames all have the same number of vert, norm, faces for animation
	long	number_of_vertexs;
	long	number_of_UVs;
	long	number_of_normals;
	long	number_of_faces;		//number of faces
	float	*vertex_array;			//3 floats per vertex
	float	*UV_array;				//2 UVs per vextex
	float	*normal_array;			//3floats per vertex
	long	*face_array;			//3vt 3tx 3norms (9 longs perface)
	
	//ARRAYS MARKING OBJECT FINISHING POINTS
	long *frame_face_number;

	
};


#endif