#include "main.h"
#include "display_as_animation.h"

//displays each object as a separate frame, each object must have the same number of verts etc
void display::play(obj_model *model_pointer,int start, int end)
{
	glEnable(GL_TEXTURE_2D);
	//glDisable(GL_LIGHTING);
	long total_faces =(model_pointer->number_of_faces);			//number of faces
	int number_of_frames = model_pointer->number_of_objects;		//number of frames
	int j,k;														//counters
	int vertex_index;	//index long varible 
	int vertex_index_nxt;
	int coord_Index;
	int normal_index;
	int temp_counter;
	glBegin(GL_TRIANGLES);
	//frame counter goes round
	if (Frame_Counter<start || Frame_Counter>end)Frame_Counter=start;
	t=t+0.2;
	if (t>=1)
	{
		Frame_Counter++;
		t=0;
	}
	if	(Frame_Counter > number_of_frames || Frame_Counter > end)

		Frame_Counter=start;
		
	//initiating max and min faces
    long maxFace =Frame_Counter		*total_faces;
	long minFace =(Frame_Counter-1)	*total_faces;
	//max and min next frame faces
	long MaxNextFrame;
	long MinNextFrame;	
	
	if (Frame_Counter+1>number_of_frames)
	{
		MaxNextFrame = total_faces;
		MinNextFrame =0;
	}
	else 
	{
		MaxNextFrame = Frame_Counter +1	*total_faces;
		MinNextFrame = Frame_Counter	*total_faces;
	}
	float array[3];
	//our second set of counters for our next frame coordinates
	int m=MaxNextFrame;
	int n=MinNextFrame;


	//bind the textures
	glBindTexture(GL_TEXTURE_2D, model_pointer->material_ID[0]);

	//looping through each face of the current frame
	for (j=minFace; j<maxFace; j++)//j is going from zero to 1807 (gOOd!)
		{
		//looping through each vertex of the face
		for (k=0; k<3; k++)
			{
					
			//texuring a the face vertex
			normal_index =		model_pointer->face_array[j*9+k+6]*3;
			vertex_index_nxt =	model_pointer->face_array[n*9+k+6]*3;
            
			array[0]	=	model_pointer->normal_array[ normal_index]	+ t *	(model_pointer->normal_array[vertex_index_nxt]
																		    -	 model_pointer->normal_array[ normal_index]);	 
			array[1]	=	model_pointer->normal_array[ normal_index+1]+ t *	(model_pointer->normal_array[vertex_index_nxt+1]
																		    -	 model_pointer->normal_array[ normal_index+1]);	 
			array[2]	=	model_pointer->normal_array[ normal_index+2]+ t *	(model_pointer->normal_array[vertex_index_nxt+2]
																		    -	 model_pointer->normal_array[ normal_index+2]);	 


			glNormal3f(		array[0], 
							array[1],
							array[2]);
			//coordinate loop
			//coord_Index =	model_pointer->face_array[j*9+k+3]*2;
		    //glTexCoord2fv( &model_pointer->UV_array[ coord_Index]);
							
						
			glColor3f(0.7f, 0.0f, 0.0f);
			vertex_index =	model_pointer->face_array[j*9+k] *3;
			vertex_index_nxt = model_pointer->face_array[n*9+k] *3;
             
			array[0]	 = model_pointer->vertex_array[vertex_index]	+ t *	(model_pointer->vertex_array[vertex_index_nxt]
																			-	 model_pointer->vertex_array[vertex_index]);
			array[1]	 = model_pointer->vertex_array[vertex_index+1]	+ t *	(model_pointer->vertex_array[vertex_index_nxt+1]
																			-	 model_pointer->vertex_array[vertex_index+1]);
			array[2]	 = model_pointer->vertex_array[vertex_index+2]	+ t *	(model_pointer->vertex_array[vertex_index_nxt+2]
																			-	 model_pointer->vertex_array[vertex_index+2]);

			//frameC  = frame1 + percent *(frame2-frame1)	
			glVertex3f(	array[0],	array[1],	array[2]);
			}
			n++;
		}
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);
}

//displays all objects as one mesh
void display::showAll(obj_model *model_pointer)
{
glEnable(GL_TEXTURE_2D);

	long all_faces=model_pointer->background_faces;
	int j,k;			//counters
	int vertex_index;	//index long varible 
	int coord_Index;
	int normal_index;

glBegin(GL_TRIANGLES);
for (j=0; j<all_faces; j++)//j is going from zero to 1807 (gOOd!)
		{
		//looping through each vertex of the face
		for (k=0; k<3; k++)
			{
			//normals
			normal_index =model_pointer->face_array[j*9+k+6]*3;
			            
			glNormal3f(	model_pointer->normal_array[ normal_index],	
						model_pointer->normal_array[ normal_index+1],
						model_pointer->normal_array[ normal_index+2]);

			
			//coordinate loop
			//coord_Index =   model_pointer->face_array[j*9+k+3]*2;
			//glTexCoord2fv( &model_pointer->UV_array[coord_Index]);
							
						
			glColor3f(1.0f, 1.0f, 1.0f);
			vertex_index =	model_pointer->face_array[j*9+k] *3;
			             
			glVertex3f( model_pointer->vertex_array[vertex_index],
						model_pointer->vertex_array[vertex_index+1],		
						model_pointer->vertex_array[vertex_index+2]);
			
		
			}
			
		}
	glEnd();
	glDisable(GL_TEXTURE_2D);
}




