#include "main.h"


//global varibles
CCamera	g_Camera;
long Frame_Counter=1;
float t=0;
int cycles_taken =0;

//maya mouse globals
float LastX=0;
float LastY=0;
unsigned int left__mouse	=0;
unsigned int middle__mouse	=0;

float zoom_mouse;
float step_mouseX;
float step_mouseY;
float translate_mouse_x;
float translate_mouse_y;
float rotate_mouse_x;
float rotate_mouse_y;
float slow_down_for_search_key=2;
int loops = 2;
float slow_down_end_temp=0.2;
int search_algorithm = 4 ;


// Enables "multi-pressed" key combinations by using keyIndex as a key map
char keyIndex[256];
Ctextures teapot;
obj_model background_mesh;
obj_model arrow;
obj_model character;
objLoader open_file;
objLoader open_file2;
objLoader open_file3;
path_a waypoints;
Ctextures skin;
Clighting pointLight;
display view;
display view2;
GLuint tex;
colision ground;
float translate = 0.0;
void init(void)
{		

	//load and create texture
	//open_file.ImportObj(&character,"walk.obj");

	int selection;
	//load scene
	cout <<endl<<"PATHFINDER"<<endl;
	cout <<endl<<endl<<endl<< "select Map (range 2 - 6): ";
	cin  >>selection;
	
	cout <<endl<<endl<<endl<< "level of detail: ";
	float detail;
	if (4 > detail || detail > 0.1 )detail=0.5;
	cin  >>detail;

	if (2>selection ||selection >6)selection=2;
	switch (selection)
	{
	case 1: open_file2.ImportObj(&background_mesh,"maze1.obj");break;
	case 2:	open_file2.ImportObj(&background_mesh,"maze2.obj");break;
	case 3:	open_file2.ImportObj(&background_mesh,"maze3.obj");break;
	case 4:	open_file2.ImportObj(&background_mesh,"maze4.obj");break;
	case 5:	open_file2.ImportObj(&background_mesh,"maze5.obj");break;
	case 6:	open_file2.ImportObj(&background_mesh,"maze6.obj");break;
	default:open_file2.ImportObj(&background_mesh,"maze2.obj");break;
	}
	
	if (0.25>detail ||detail >3.5)detail=0.5;
	ground.grid(&background_mesh, detail);//reduce mesh by multiples of 2
	skin.loader("file.tga");
	skin.createTexture(tex);
		


	teapot.material();
	
	pointLight.setup();
	pointLight.position();
	
	//glutSetCursor(GLUT_CURSOR_NONE);
	
	g_Camera.setupDisplay();

	g_Camera.Position(0, 52.5f, 0.1,   0, 0.5f, 0,   0, 1, 0);
	//
	waypoints.set_path(&ground, 0, 0);
	
	

}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	
	waypoints.make_path();
	waypoints.move_path(&ground);
	//waypoints.draw_route();
	
	view.showAll(&background_mesh);
		glDisable(GL_LIGHTING);
		ground.display();

		glEnable(GL_LIGHTING);
	
		g_Camera.update();
	glutSwapBuffers();
	
	
	//these must be placed at the end
	pointLight.position();

}


void keyboard(int key, int x, int y)
{

	if (key < 0 || key > 255) {
		cout << key << endl << flush;
	}else

keyIndex[(char)key]=1;

}
void keyUp(int key, int x, int y)
{
	if (key < 0 || key > 255) {
		cout << key << endl << flush;
	}
keyIndex[(char)key]=0;
}



void mouseMotion(int x, int y)
{
	   step_mouseX = x-LastX;
	   step_mouseY = y-LastY;

	if(left__mouse && middle__mouse)
	{
		//zoom
		zoom_mouse += 0.2f*step_mouseX;
		//g_Camera.move(zoom_mouse);
	}
	else
	if(left__mouse)
	{
		//rotate
		rotate_mouse_x += 0.5f*step_mouseY;
		rotate_mouse_y += 0.5f*step_mouseX;
	}
	else
	if(middle__mouse)
	{


		//move
		translate_mouse_x  += 0.2f*step_mouseX;
		translate_mouse_y  -= 0.2f*step_mouseY;
	}
    LastX = x;
    LastY = y;
	g_Camera.update();


	
}

void mouse(int button, int state, int x, int y)
{

 if(state == GLUT_DOWN)
 {
		switch(button)
		{
		case GLUT_LEFT_BUTTON:
			left__mouse = 1;
            break;
		case GLUT_MIDDLE_BUTTON:
			middle__mouse = 1;
            break;
		
		default:
            break;
		}
		
}
 else
 {
	    switch(button)
		{
		case GLUT_LEFT_BUTTON:
			left__mouse =	0;
            break;
		case GLUT_MIDDLE_BUTTON:
			middle__mouse = 0;
            break;
		
		default:
            break;
		}
         }
 g_Camera.update();
}

void idle()
{
	g_Camera.update();
	

}


void main(int argc,char *argv[])
{
	glutInit(&argc,argv); 
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
	glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);	
	glutInitWindowPosition(120,120);
	glutCreateWindow("PathFinding ");
try {
	init();  
	glutSpecialFunc(keyboard);
	glutSpecialUpFunc(keyUp);
	glutMouseFunc(mouse);
	glutMotionFunc(mouseMotion);
	glutPassiveMotionFunc(mouseMotion);
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	glutMainLoop();

} catch (...) {
	cout << "caught something\n" << flush;
	

}

}
